import java.awt.Button;
import java.awt.Color;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class UE20Aufgabe26 {

	final static int N = 4;

	public static void main(String[] args) {
		Frame fenster = new Frame("Lights");
		fenster.setLayout(new GridLayout(N, N));
		Button[][] lights = new Button[N][N];
		for (int r = 0; r < lights.length; r++) {
			for (int c = 0; c < lights[r].length; c++) {
				lights[r][c] = new Button("");
				lights[r][c].setBackground(Color.WHITE);
				lights[r][c].addActionListener(new ClickListener(lights, r, c));
				fenster.add(lights[r][c]);
			}
		}
		fenster.setBounds(10, 10, 300, 300);
		fenster.setVisible(true);

	}
}

class ClickListener implements ActionListener {

	Button[][] buttons;
	int row;
	int col;

	ClickListener(Button[][] buttons, int r, int c) {
		this.buttons = buttons;
		this.row = r;
		this.col = c;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		switchColor(buttons[row][col]);
		if (row - 1 >= 0) {
			switchColor(buttons[row - 1][col]);
		}
		if (row + 1 < buttons.length) {
			switchColor(buttons[row + 1][col]);
		}
		if (col + 1 < buttons[row].length) {
			switchColor(buttons[row][col + 1]);
		}
		if (col - 1 >= 0) {
			switchColor(buttons[row][col - 1]);
		}

	}

	private void switchColor(Button button) {
		if (button.getBackground().equals(Color.WHITE)) {
			button.setBackground(Color.YELLOW);
		} else {
			button.setBackground(Color.WHITE);
		}
	}

}
